# Copyright (C) GemTalk Systems 1986-2014.  All Rights Reserved.
#
# GDB commands for GemStone's pstack for Linux and Darwin

# Get a full stack with no user interaction
set confirm off
set pagination off
set backtrace limit 0

handle SIGIO pass nostop noprint
handle SIGPOLL pass nostop noprint
handle SIGPIPE pass nostop noprint
handle SIGWINCH pass nostop noprint
handle SIGFPE pass nostop noprint
handle SIGUSR1 pass nostop noprint
handle SIGUSR2 pass nostop noprint
handle SIGQUIT pass nostop print
handle SIG33 pass nostop noprint
handle SIG34 pass nostop noprint
handle SIG32 pass nostop noprint
handle SIGVTALRM pass nostop noprint

# get stacks with one line per frame
thread apply all backtrace

# get the stacks of all threads, dumping local variables
#   if available.
thread apply all backtrace full

# print smalltalk stacks, one line per frame
print printStack(0)
# print smalltalk stack with receiver, args, temps for each frame
print printStack(2)

# do last, it may not be resolvable
print IntLpBCLoop

# Done, let the process continue
detach
