!=========================================================================
! Copyright (C) by GemTalk Systems 1991-2016.  All Rights Reserved
!
!=========================================================================
category: 'Converting - PetitParser'
method: CharacterCollection
asParser
	"Answer a parser that accepts the receiving string."

	^ PPLiteralSequenceParser on: self
%

category: 'Index Query Support'
method: CharacterCollection
asQueryOn: anNsc
  ^ GsQuery fromString: self on: anNsc
%
method:
asCachedQueryOn: anNsc
  ^ GsQuery
    fromString: self
    on: anNsc
    options: GsQueryOptions default + GsQueryOptions cacheQueryResult
%
method:
asCachedQuery
  ^ GsQuery
    fromString: self
    options: GsQueryOptions default + GsQueryOptions cacheQueryResult
%
method:
asQuery
  ^ GsQuery fromString: self
%
category: 'New Indexing Comparison - for Compare'
method: CharacterCollection
_idxForCompareEqualToUnicode: aUnicodeString collator: anIcuCollator
  "REL_SIG_STRING_SIZE = 900"

  ^ (aUnicodeString compareTo: self collator: anIcuCollator useMinSize: 900)
    == 0
%
category: 'New Indexing Comparison - for Compare'
method: CharacterCollection
_idxForCompareGreaterThanUnicode: aUnicodeString collator: anIcuCollator
  "REL_SIG_STRING_SIZE = 900"

  ^ (aUnicodeString
    compareTo: self
    collator: anIcuCollator
    useMinSize: 900) == 1
%
category: 'New Indexing Comparison - for Compare'
method: CharacterCollection
_idxForCompareGreaterThanOrEqualToUnicode: aUnicodeString collator: anIcuCollator
  "REL_SIG_STRING_SIZE = 900"

  ^ (aUnicodeString
    compareTo: self
    collator: anIcuCollator
    useMinSize: 900) >= 0
%
category: 'New Indexing Comparison - for Compare'
method: CharacterCollection
_idxForCompareLessThanUnicode: aUnicodeString collator: anIcuCollator
  "REL_SIG_STRING_SIZE = 900"

  ^ (aUnicodeString
    compareTo: self
    collator: anIcuCollator
    useMinSize: 900) == -1
%
category: 'New Indexing Comparison - for Compare'
method: CharacterCollection
_idxForCompareLessThanOrEqualToUnicode: aUnicodeString collator: anIcuCollator
  "REL_SIG_STRING_SIZE = 900"

  ^ (aUnicodeString
    compareTo: self
    collator: anIcuCollator
    useMinSize: 900) <= 0
%
category: 'New Indexing Comparison - for Sort'
method: CharacterCollection
_idxForSortEqualToCharacterCollection: aCharacterCollection collator: anIcuCollator
  "REL_SIG_STRING_SIZE = 900"

  ^ (aCharacterCollection
    compareTo: self
    collator: anIcuCollator
    useMinSize: 900) == 0
%
category: 'New Indexing Comparison - for Sort'
method: CharacterCollection
_idxForSortGreaterThanCharacterCollection: aCharacterCollection collator: anIcuCollator
  "REL_SIG_STRING_SIZE = 900"

  ^ (aCharacterCollection
    compareTo: self
    collator: anIcuCollator
    useMinSize: 900) == 1
%
category: 'New Indexing Comparison - for Sort'
method: CharacterCollection
_idxForSortGreaterThanOrEqualToCharacterCollection: aCharacterCollection collator: anIcuCollator
  "REL_SIG_STRING_SIZE = 900"

  ^ (aCharacterCollection
    compareTo: self
    collator: anIcuCollator
    useMinSize: 900) >= 0
%
category: 'New Indexing Comparison - for Sort'
method: CharacterCollection
_idxForSortLessThanCharacterCollection: aCharacterCollection collator: anIcuCollator
  "REL_SIG_STRING_SIZE = 900"

  ^ (aCharacterCollection
    compareTo: self
    collator: anIcuCollator
    useMinSize: 900) == -1
%
category: 'New Indexing Comparison - for Sort'
method: CharacterCollection
_idxForSortLessThanOrEqualToCharacterCollection: aCharacterCollection collator: anIcuCollator
  "REL_SIG_STRING_SIZE = 900"

  ^ (aCharacterCollection
    compareTo: self
    collator: anIcuCollator
    useMinSize: 900) <= 0
%
category: 'New Indexing Comparison'
method: CharacterCollection
_idxForSortEqualToSymbol: aSymbol
  ""

  ^ self _idxPrimCompareEqualTo: aSymbol asString
%
category: 'New Indexing Comparison'
method: CharacterCollection
_idxForCompareEqualToCharacterCollection: arg
  ""

  ^ self _idxPrimCompareEqualTo: arg
%
